/* == PLUGIN METHODS == */

/**
 * Checks whether the dependent plugin has the correct version
 */
/* NAMESPACE */checkVersion = function(module, minVersion, maxVersion) {
    // If maxVersion is not set, set it to -1 (no limit)
    if(!maxVersion && maxVersion !== 0) {
        maxVersion = -1;
    }
    // Splits the module name into an array
    module = module.split('.');
    
    // The base object to find the module in
    var elem = window;
    var version = null;
    
    // Searches if the element exists
    for(var idx = 0; idx < module.length; idx++) {
        var sub = module[idx];
        if(!elem[sub]) {
            elem = null;
            break;
        }
        elem = elem[sub];
    }
    
    // Sets the version number of the module
    if(!elem) {
        if(Imported[module]) {
            version = (Imported[module] + '').split('.');
        }
    } else if(elem instanceof Object) {
        version = (elem.version + '').split('.');
    } else {
        // In case the version number is stored elsewhere, this can
        // be directly referenced
        version = (elem + '').split('.');
    }
    // Check the version with the minimum and maximum version number
    if(version) {
        if(!Array.isArray(minVersion)) {
            minVersion = (minVersion + '').split('.');
        }
        if(maxVersion !== -1 && !Array.isArray(maxVersion)) {
            maxVersion = (maxVersion + '').split('.');
        }
        for(var idx = 0; idx < version.length; idx++) {
            if(idx >= minVersion.length) {
                continue;
            }
            if(version[idx] < minVersion[idx]) {
                return false;
            }
            if(maxVersion !== -1) {
                if(idx >= maxVersion.length) {
                    continue;
                }
                if(version[idx] > maxVersion[idx]) {
                    return false;
                }
            }
        }
    }
    return false;
}

/* NAMESPACE */checkVersion.version = '1.0';