/* == PRIVATE VARIABLES == */
var _pluginCommands = {};     // Holds all plugin commands

/* == ALIASES == */

_old.gameInterpreterPluginCommand = Game_Interpreter.prototype.pluginCommand;

/* == PLUGIN METHODS == */

/**
 * Easy function to add new plugin commands
 */
if(Imported['WAY_Core'] && PluginManager.addCommand) {
    /* NAMESPACE */addPluginCommand = PluginManager.addCommand;
    _coreExists.pluginCommand = 'WAY_Core';
} else {
    /* NAMESPACE */addPluginCommand = function(command, func) {
        _pluginCommands[command] = func;
    }
}

/* == PLUGIN OVERRIDES == */

/* --------------------------------------------------------------------
 * - Game_Interpereter.prototype.pluginCommand (Override)             -
 * --------------------------------------------------------------------
 */
if(!_coreExists.pluginCommand) {
    Game_Interpreter.prototype.pluginCommand = function(command, args) {
        if(_pluginCommands.hasOwnProperty(command)) {
            _pluginCommands[command].call(this, args);
        } else {
            _old.gameInterpreterPluginCommand.call(this, command, args);
        }
    }
}